*********************************************************************************
*																				*
*		Foxpro SQL to SQL-standard statements converting in a program text		*
*																				*
*					(c) Pinter Consulting, A.Evsikow 2005						*
*																				*
*********************************************************************************
* Purpose......: Takes a highlighted block of code from a PRG, SPR or SCX file and uses
*              : EFOXSQL.FLL to build the T-SQL equivalent and put it into the paste buffer
* Usage........: Before using, enter ON KEY LABEL F3 DO E_SQL_Text_Convert
*              : Then, in any code editing context, highlight a SELECT statement and F3. 
* Notes........: Use a "Hungarian notation" with prefix ~ before type symbol to
*			   : refer to variables. For example: ~n - before numeric variable references,
*			   : ~c - before char variables, ~l - before logical, ~d - date, ~t - time
*			   : You can also refer to FoxPro expressions with this notation! Just
*			   : take an expressions into brackets. For example: ~c(char expression),
*			   : ~n(numeric expression)
*			   : See a manual for details !!!
**********************************************************************************

#Define DATA_IF				"IF m._SQL"					&& Replace this definition with valid
#Define SQL_ERROR_ROUTINE	"Do SQL_Error With m.Cmd"	&& Replace this definition with valid

LPARAMETERS m._JustClause
* Send .T. when You want just translate a variables references and has marked jast a part or
* Select statement (Where or Select or ...)

SET LIBRARY TO d:\_efoxsql\efoxsql.fll
* Replace a reference to FOXSQL.FLL with valid !!!

* Take a selected in editor text using API
_cliptext	= ''
= E_Editor_Copy()
IF NOT EMPTY(_cliptext)
	_Screen.Tag	= _cliptext
ENDIF
IF EMPTY(_Screen.Tag)
	RETURN 
ENDIF 
* Last highlighted block will be saved into _Screen.Tag !!!

SETLOCSYS_SQL_Server_Select_NoLock	= .T.	&& WITH (NOLOCK) clause will be added after each table reference in FROM clause
											&& See SET TRANSACTION ISOLATION LEVEL in SQL Server documentation
___EFOXSQL_Set_DToC_Style			= 103	&& A style for data conversion. See CAST and CONVERT functionsin in SQL Server documentation

Cr		= CHR(13) 
CrLf	= CHR(13)+CHR(10) 
Tab		= CHR(9)

Str = _Screen.Tag
IF LEN(Str) = 0 
	MESSAGEBOX("Nothing in paste buffer!",16,"Highlight something and press Ctrl+C",1000)
	RETURN 
ENDIF 

m._Margin	= ''
I	= 1
DO WHILE SUBSTR(Str,I,1) = ' ' OR SUBSTR(Str,I,1) = '	'
	m._Margin	= m._Margin + SUBSTR(Str,I,1)
	I			= I + 1
ENDDO 

* Is Locate ?
* If You will put SELECT Alias statement befor LOCATE FOR statement, it will be translated
* as SELECT * From alias WHERE + for clause
m._Locate	= .F.
J	= AT(CHR(13),Str)
IF J > 0
	I	= J + 1
	DO WHILE I <= LEN(Str)
		m._Symb	= SUBSTR(Str,I,1)
		IF m._Symb <> CHR(10) AND m._Symb <> ' ' AND m._Symb <> '	'
			EXIT 
		ENDIF
		I	= I + 1
	ENDDO 
	IF I <= LEN(Str) AND LEFT(UPPER(SUBSTR(Str,I)),6) = 'LOCATE'
		m._Locate	= .T.
	ENDIF 
ENDIF 

IF m._Locate
	Str4	= SUBSTR(Str,1,J-1)
	Str2	= STRTRAN(UPPER(SUBSTR(Str,1,J-1)),Tab + [SELECT],[SELECT * From]) + ';' + CrLf + m._Margin + Tab + 'WHERE ' + ALLTRIM(SUBSTR(ALLTRIM(SUBSTR(Str,I+6)),4))
ELSE 
	Str2	= Str
ENDIF 

* Remove CR, LF and ";"
m._At	= AT(CHR(13),Str2)
DO WHILE m._At > 0
	Str2		= STUFF(Str2,m._At,1,' ')
	IF SUBSTR(m.Str2,m._At+1,1) = CHR(10)
		Str2	= STUFF(Str2,m._At+1,1,'')
	ENDIF 
	m._At	= m._At - 1
	m._Symb	= SUBSTR(m.Str2,m._At,1)
	DO WHILE m._At > 0 AND (m._Symb = ' ' OR m._Symb = '	')
		Str2	= STUFF(Str2,m._At,1,'')
		m._At	= m._At - 1
		m._Symb	= SUBSTR(m.Str2,m._At,1)
	ENDDO 
	IF m._At > 0 AND m._Symb = ';'
		Str2	= STUFF(Str2,m._At,1,'')
	ENDIF 
	m._At	= AT(CHR(13),Str2)
ENDDO 

* Replace " with '
Str2	= _Stuff(ALLTRIM(Str2),["],['])
Str2	= _Stuff(Str2,[==],[=])
Str2	= _Stuff(Str2,[&],[~c])

IF m._JustClause
	Str3 	= ["] + _TranVar(str2) + ["]
	_ClipText = ;
		m._Margin + DATA_IF + CrLf +;
		m._Margin + Tab + Str3 + CrLf + [ ELSE] + CrLf +;
		m._Margin + Tab + E_SQL_REMOVE_DIRECTIVES(STRTRAN(STRTRAN(Str,Cr,CrLf),CrLf,CrLf+Tab)) + IIF(RIGHT(ALLTRIM(Str),2)=CrLf or RIGHT(ALLTRIM(Str),1)=Cr,'',CrLf)
		IF RIGHT(_ClipText,1) = Tab
			_ClipText	= SUBSTR(_ClipText,1,LEN(_ClipText)-1)
		ENDIF 
		_ClipText	= _ClipText + m._Margin + [ENDIF] + CrLf
	IF MESSAGEBOX(_ClipText,36,[Replace selected text with this string ? (Also saved in paste buffer)]) = 6
		= E_Editor_Paste()
	ENDIF 
	RETURN
ENDIF 	

Str2 	= ["] + _TranVar(E_SQL_SELECT_CONVERT(str2)) + ["]
Str		= _TranVar(str,.T.)

I		= 1
m._At	= AT(' UNION ',Str2)
DO WHILE m._At > 0
	Str2	= STUFF(Str2,m._At,0,["+;] + CrLf + m._Margin + [	"])
	I		= I + 1
	m._At	= AT(' UNION ',Str2,I)
ENDDO
I		= 1
m._At	= AT(' FROM ',Str2)
DO WHILE m._At > 0
	Str2	= STUFF(Str2,m._At,0,["+;] + CrLf + m._Margin + [	"])
	I		= I + 1
	m._At	= AT(' FROM ',Str2,I)
ENDDO
I		= 1
m._At	= AT(' WHERE ',Str2)
DO WHILE m._At > 0
	Str2	= STUFF(Str2,m._At,0,["+;] + CrLf + m._Margin + [	"])
	I		= I + 1
	m._At	= AT(' WHERE ',Str2,I)
ENDDO
I		= 1
m._At	= AT(' GROUP BY ',Str2)
DO WHILE m._At > 0
	Str2	= STUFF(Str2,m._At,0,["+;] + CrLf + m._Margin + [	"])
	I		= I + 1
	m._At	= AT(' GROUP BY ',Str2,I)
ENDDO 
I		= 1
m._At	= AT(' HAVING ',Str2)
DO WHILE m._At > 0
	Str2	= STUFF(Str2,m._At,0,["+;] + CrLf + m._Margin + [	"])
	I		= I + 1
	m._At	= AT(' HAVING ',Str2,I)
ENDDO 
m._At	= AT(' ORDER BY ',Str2)
IF m._At > 0
	Str2	= STUFF(Str2,m._At,0,["+;] + CrLf + m._Margin + [	"])
ENDIF 

J	= 0
I	= 1
DO WHILE I <= LEN(Str2)
	J	= J + 1
	m._Symb	= SUBSTR(m.Str2,I,1)
	IF m._Symb = CHR(13)
		J	= 0
	ELSE
		IF J > 80
			DO WHILE I <= LEN(Str2) AND m._Symb <> ' ' AND m._Symb <> '	'
				I		= I + 1
				m._Symb	= SUBSTR(m.Str2,I,1)
			ENDDO
			IF I <= LEN(Str2)
				Str2	= STUFF(Str2,I,0,';'+CrLf + m._Margin + Tab)
			ENDIF 
			J		= 0
		ENDIF
	ENDIF
	I	= I + 1
ENDDO 

J	= 0
I	= 1
DO WHILE I <= LEN(Str2)
	J	= J + 1
	m._Symb	= SUBSTR(m.Str2,I,1)
	IF m._Symb = '"'
		J	= 0
	ELSE
		IF J > 100
			DO WHILE I <= LEN(Str2) AND m._Symb <> ' ' AND m._Symb <> '	'
				I		= I + 1
				m._Symb	= SUBSTR(m.Str2,I,1)
			ENDDO
			IF I <= LEN(Str2)
				Str2	= STUFF(Str2,I,0,[" + "])
			ENDIF 
			J		= 0
		ENDIF
	ENDIF
	I	= I + 1
ENDDO 

Str3	= "Cmd = " + Str2
*IF NOT m._Locate

	_ClipText = ;
		m._Margin + DATA_IF + CrLf +;
		m._Margin + Tab + Str3 + CrLf + ;
		'*' + m._Margin + Tab + [IF SQLExec(nHandle,Cmd,cAlias)<=0] + CrLf +;
		'*' + m._Margin + Tab + Tab + SQL_ERROR_ROUTINE + CrLf +;
		'*' + m._Margin + Tab + [ENDIF] + CrLf

	_ClipText	= _ClipText +;
		m._Margin + [ELSE] + CrLf + Tab + E_SQL_REMOVE_DIRECTIVES(STRTRAN(STRTRAN(Str,Cr,CrLf),CrLf,CrLf+Tab)) + IIF(RIGHT(ALLTRIM(Str),2)=CrLf or RIGHT(ALLTRIM(Str),1)=Cr,'',CrLf)
		_ClipText	= RTRIM(_ClipText)
		IF RIGHT(_ClipText,1) = Tab
			_ClipText	= SUBSTR(_ClipText,1,LEN(_ClipText)-1)
		ENDIF 
		_ClipText	= _ClipText + m._Margin + [ENDIF] + CrLf
*ELSE
*	_ClipText = ;
*		Str3 + CrLf +;
*    	[oDataTier.GetMatchingRecords ( "] + _GetFrom(Str2) + [", Fields, Cmd, AlternateCursorName )] + CrLf +;
*    	E_SQL_REMOVE_DIRECTIVES(CHRTRAN(Str,[;]+Cr,[;]+CrLf+Tab))
*ENDIF

IF MESSAGEBOX(_ClipText,36,[Replace selected text with this string ? (Also saved in paste buffer)]) = 6
	m._CTxt	= _ClipText
	m._Org	= ALLTRIM(_Screen.Tag)
	DO WHILE RIGHT(m._Org,1) = ';' OR RIGHT(m._Org,1) = CHR(10) OR RIGHT(m._Org,1) = CHR(13) OR RIGHT(m._Org,1) = ' ' OR RIGHT(m._Org,1) = '	'
		m._Org	= SUBSTR(m._Org,1,LEN(m._Org)-1)
	ENDDO 
	m._Org	= STRTRAN(m._Org,Cr,Cr + '*!*	') + CrLf
	m._Org	= STRTRAN(m._Org,CrLf,CrLf + '*!*	') + CrLf
	m._Org	= '*!*	<<CHANGE>>' + CrLf + '*!*	' + m._Org + CrLf

*	m._Org	= STRTRAN(m._Org,CrLf,CrLf + '*!*	') + CrLf
	_ClipText	= m._Org + _ClipText
	= E_Editor_Paste()
	_ClipText	= m._CTxt
ENDIF 

************************************************************************
* Searching substring ignore constant brackets
*
FUNCTION _At
LPARAMETERS m._SubStr,m._Str

	LOCAL I,	m._Symb,	J,	m._f,	m._t
	I		= 1
	m._f	= 1

	DO WHILE I <= LEN(m._Str)
		m._Symb	= SUBSTR(m._Str,I,1)
		IF m._Symb = m._SubStr
			RETURN I
		ELSE 
			DO CASE 
				CASE m._Symb = [']
					m._t	= I - 1
					J		= AT(m._SubStr,m._Str)
					IF J >= m._f AND J <= m._t
						RETURN J
					ENDIF 
					I	= I + 1
					DO WHILE I <= LEN(m._Str) AND SUBSTR(m._Str,I,1) <> [']
						I	= I + 1
					ENDDO 
					I		= I + 1
					m._f	= I
					LOOP
				CASE m._Symb = ["]
					m._t	= I - 1
					J		= AT(m._SubStr,m._Str)
					IF J >= m._f AND J <= m._t
						RETURN J
					ENDIF 
					I	= I + 1
					DO WHILE I <= LEN(m._Str) AND SUBSTR(m._Str,I,1) <> ["]
						I	= I + 1
					ENDDO 
					I		= I + 1
					m._f	= I
					LOOP
				CASE m._Symb = "["
					m._t	= I - 1
					J		= AT(m._SubStr,m._Str)
					IF J >= m._f AND J <= m._t
						RETURN J
					ENDIF 
					I	= I + 1
					J	= 0
					DO WHILE I <= LEN(m._Str)
						m._Symb	= SUBSTR(m._Str,I,1)
						DO CASE 
							CASE m._Symb = '['
								J	= J + 1
							CASE m._Symb = ']'
								IF J > 0
									J	= J - 1
								ELSE
									EXIT 
								ENDIF
						ENDCASE 
						I	= I + 1
					ENDDO 
					I		= I + 1
					m._f	= I
					LOOP 
				CASE m._Symb = "~" AND SUBSTR(m._Str,I+1,1) = '('
					m._t	= I - 1
					J		= AT(m._SubStr,m._Str)
					IF J >= m._f AND J <= m._t
						RETURN J
					ENDIF 
					I	= I + 2
					J	= 0
					DO WHILE I <= LEN(m._Str)
						m._Symb	= SUBSTR(m._Str,I,1)
						DO CASE 
							CASE m._Symb = '('
								J	= J + 1
							CASE m._Symb = ')'
								IF J > 0
									J	= J - 1
								ELSE
									EXIT 
								ENDIF
						ENDCASE 
						I	= I + 1
					ENDDO 
					I		= I + 1
					m._f	= I
					LOOP 
			ENDCASE
		ENDIF 
		I	= I + 1
	ENDDO 
RETURN 0

************************************************************************
* Searchin notation ~ (prefix). Accept a first symbol after ~ as type
* of variable and replace variable reference with constant reference
* To remove a notation (for FoxPro case) - pass a second parameter not empty
*
FUNCTION _TranVar
LPARAMETERS m._Str,m._Fox

	LOCAL I,	m._Type,	m._BClose,	m._EClose,	m._SetDate

	m._SetDate	= SET("Date")
	SET DATE TO YMD

	I	= _At('~',m._Str)
	J	= 0
	DO WHILE I > 0

		I	= I + J
		DO WHILE I + 1 <= LEN(m._Str) AND (SUBSTR(m._Str,I+1,1) = ' ' OR SUBSTR(m._Str,I+1,1) = '	')
			m._Str	= STUFF(m._Str,I+1,1,'')
		ENDDO 

		m._Type		= UPPER(SUBSTR(m._Str,I+1,1))
		m._EOpen	= ''
		m._EClose	= ''
		DO CASE 
			CASE m._Type = 'N' OR m._Type = 'I' OR m._Type = 'B' OR m._Type = 'F'
				IF m._Fox
					m._Str	= STUFF(m._Str,I,2,'')
				ELSE 
					m._EOpen	= '"+TRANSFORM('
					m._Str		= STUFF(m._Str,I,2,m._EOpen)
					I			= I + LEN(m._EOpen)
					m._EClose	= ')+"'
				ENDIF 
			CASE m._Type = 'L'
				IF m._Fox
					m._Str	= STUFF(m._Str,I,2,'')
				ELSE 
					m._EOpen	= '"+IIF('
					m._Str		= STUFF(m._Str,I,2,m._EOpen)
					I			= I + LEN(m._EOpen)
					m._EClose	= ',"cast(1 as bit)","cast(0 as bit)")+"'
				ENDIF 
			CASE m._Type = 'D'
				IF m._Fox
					m._Str	= STUFF(m._Str,I,2,'')
				ELSE 
					m._EOpen	= ['"+STRTRAN(DTOC(]
					m._Str		= STUFF(m._Str,I,2,m._EOpen)
					I			= I + LEN(m._EOpen)
					m._EClose	= [),'/','-')+"']
				ENDIF 
			CASE m._Type = 'T'
				IF m._Fox
					m._Str	= STUFF(m._Str,I,2,'')
				ELSE 
					m._EOpen	= ['"+STRTRAN(TTOC(]
					m._Str		= STUFF(m._Str,I,2,m._EOpen)
					I			= I + LEN(m._EOpen)
					m._EClose	= [),'/','-')+"']
				ENDIF 
			CASE m._Type = 'C'
				IF m._Fox
					m._Str	= STUFF(m._Str,I,2,'')
				ELSE 
					m._EOpen	= ['"+]
					m._Str		= STUFF(m._Str,I,2,m._EOpen)
					I			= I + LEN(m._EOpen)
					m._EClose	= [+"']
				ENDIF 
			CASE m._Type = '?'
				IF m._Fox
					m._Str	= STUFF(m._Str,I,2,'')
				ELSE 
					m._EOpen	= ["+oDataTier.TR(]
					m._Str		= STUFF(m._Str,I,2,m._EOpen)
					I			= I + LEN(m._EOpen)
					m._EClose	= [)+"]
				ENDIF 
			OTHERWISE 
				IF m._Fox
					m._Str	= STUFF(m._Str,I,1,'')
				ELSE 
					m._EOpen	= ["+oDataTier.TR(]
					m._Str		= STUFF(m._Str,I,1,m._EOpen)
					I			= I + LEN(m._EOpen)
					m._EClose	= [)+"]
				ENDIF 
		ENDCASE 
		IF SUBSTR(m._Str,I,1) = '('
*			IF m._Fox
				m._Str	= STUFF(m._Str,I,1,'')
*			ELSE 
*				I	= I + 1
*			ENDIF 
			J	= 0
			DO WHILE I <= LEN(m._Str)
				m._Symb	= SUBSTR(m._Str,I,1)
				DO CASE 
					CASE m._Symb = '('
						J	= J + 1
					CASE m._Symb = ')'
						IF J > 0
							J = J - 1
						ELSE
							EXIT
						ENDIF 
				ENDCASE 
				I	= I + 1
			ENDDO 
*			IF m._Fox
				m._Str	= STUFF(m._Str,I,1,'')
*			ELSE 
*				I	= I + 1
*			ENDIF 
		ELSE
			I		= I + 1
			DO WHILE I <= LEN(m._Str) 
				m._Symb	= SUBSTR(m._Str,I,1)
				IF NOT ISALPHA(m._Symb) AND NOT ISDIGIT(m._Symb) AND m._Symb <> '_' AND m._Symb <> '.'
					EXIT
				ENDIF 
				I	= I + 1
			ENDDO 
		ENDIF 
		IF NOT EMPTY(m._EClose)
			m._Str	= STUFF(m._Str,I,0,m._EClose)
			I		= I + LEN(m._EClose)
		ENDIF
		
		J	= I - 1
		I	= _At('~',SUBSTR(m._Str,I))

	ENDDO 

	SET DATE TO &_SetDate

RETURN m._Str

************************************************************************
* Stuff ignore constant brackets
*
FUNCTION _Stuff
LPARAMETERS m._Str,m._Old,m._New
	LOCAL I,	m._Symb,	J
	I	= 1
	DO WHILE I <= LEN(m._Str)
		m._Symb	= SUBSTR(m._Str,I,1)
		IF m._Symb = m._Old
			m._Str	= STUFF(m._Str,I,1,m._New)
		ENDIF 
		DO CASE 
			CASE m._Symb = [']
				I	= I + 1
				DO WHILE I <= LEN(m._Str) AND SUBSTR(m._Str,I,1) <> [']
					I	= I + 1
				ENDDO 
				IF m._Symb = m._Old
					m._Str	= STUFF(m._Str,I,1,m._New)
				ENDIF 
				I	= I + 1
				LOOP
			CASE m._Symb = ["]
				I	= I + 1
				DO WHILE I <= LEN(m._Str) AND SUBSTR(m._Str,I,1) <> ["]
					I	= I + 1
				ENDDO 
				IF m._Symb = m._Old
					m._Str	= STUFF(m._Str,I,1,m._New)
				ENDIF 
				I	= I + 1
				LOOP
			CASE m._Symb = "["
				I	= I + 1
				J	= 0
				DO WHILE I <= LEN(m._Str)
					m._Symb	= SUBSTR(m._Str,I,1)
					DO CASE 
						CASE m._Symb = '['
							J	= J + 1
						CASE m._Symb = ']'
							IF J > 0
								J	= J - 1
							ELSE
								EXIT 
							ENDIF
					ENDCASE 
					I	= I + 1
				ENDDO 
				LOOP 
			CASE m._Symb = "~" AND SUBSTR(m._Str,I+1,1) = '('
				I	= I + 2
				J	= 0
				DO WHILE I <= LEN(m._Str)
					m._Symb	= SUBSTR(m._Str,I,1)
					DO CASE 
						CASE m._Symb = '('
							J	= J + 1
						CASE m._Symb = ')'
							IF J > 0
								J	= J - 1
							ELSE
								EXIT 
							ENDIF
					ENDCASE 
					I	= I + 1
				ENDDO 
				LOOP 
		ENDCASE
		IF SUBSTR(m._Str,I,LEN(m._Old)) = m._Old
			m._Str	= STUFF(m._Str,I,LEN(m._Old),m._New)
			I	= I + LEN(m._Old) - 1
		ENDIF 
		I	= I + 1
	ENDDO 
RETURN m._Str

FUNCTION _GetFrom
LPARAMETERS m._Str

	LOCAL I,	m._Symb,	J,	m._Alias

	I	= AT('FROM',UPPER(m._Str))
	J	= 0
	DO WHILE I > 0

		I	= I + J

		m._Symb	= SUBSTR(m._Str,I-1,1)
		IF ISALPHA(m._Symb) OR ISDIGIT(m._Symb) OR m._Symb = '_'
			J	= I + 3
			I	= AT('FROM',UPPER(SUBSTR(m._Str,J+1)))
			LOOP 
		ENDIF 
		
		m._Symb	= SUBSTR(m._Str,I+4,1)
		IF ISALPHA(m._Symb) OR ISDIGIT(m._Symb) OR m._Symb = '_'
			J	= I + 3
			I	= AT('FROM',UPPER(SUBSTR(m._Str,J+1)))
			LOOP 
		ENDIF 
			
		m._Alias	= ''
		I			= I + 5
		DO WHILE I <= LEN(m._Str)
			m._Symb		= SUBSTR(m._Str,I,1)
			IF ISALPHA(m._Symb) OR ISDIGIT(m._Symb) OR m._Symb = '_'
				m._Alias	= m._Alias + m._Symb
			ELSE
				RETURN m._Alias
			ENDIF
			I	= I + 1
		ENDDO 
		
	ENDDO 
	
		